#!/bin/bash

. /usr/local/Reductor/etc/const

mkdir -p $LISTDIR

declare -A file_of
file_of['add_url']=$LISTDIR/rkn.list
file_of['add_ip_https']=$LISTDIR/rkn.iplist
file_of['add_ip_block']=$LISTDIR/rkn.ip_block
file_of['add_ip_ftp']=$LISTDIR/ip_ftp.load
file_of['need_resolv']=$LISTDIR/rkn.httpslist
file_of['add_http_port']=$LISTDIR/http.ports
file_of['add_ip_port']=$LISTDIR/rkn.ipport
file_of['bad']=$LISTDIR/dump_bad_lines

parse() {
	[ ! -f "$dump" ] && exit 0
	[ ! -s "$dump" ] && log "WARNING: empty dump.xml" && exit 0
	BLOCK_HTTPS_IP_EVEN_IF_HTTP="${filter['https_by_ip_on_http']:-0}"
	export BLOCK_HTTPS_IP_EVEN_IF_HTTP
	$BINDIR/dump_parser.py "$dump" | LANG='' sort -u > $TMPDIR/dump.parsed
}

sort_dump() {
	for list in "${file_of[@]}"; do
		> $list
	done
	while read -r cmd line; do
		[ -z "$cmd" -o "${cmd:0:1}" = "#" ] && continue
		[ -n "${file_of[${cmd:-bad}]}" ] && echo $line >> "${file_of[$cmd]}"
	done < $TMPDIR/dump.parsed
	return 0
}

main() {
	dump="${1:-$DUMPXML}"
	parse
	sort_dump
}

main "$@"
