""" put domains in json dict """
import os
import json
from dns_config import db_file, list_file

__author__ = 'oleg'


def __save(data):
    with open(db_file, 'w') as db_f:
        json.dump(data, db_f, indent=4)


def __read_db():
    if not os.path.isfile(db_file):
        __save({})
    try:
        _ = json.load(open(db_file))
    except ValueError:
        __save({})
    return json.load(open(db_file))


def main():
    """ put domains in json dict with empty/default fields """
    db_data = __read_db()
    domains = db_data.keys()
    with open(list_file, 'r') as list_f:
        for _domain in list_f.xreadlines():
            domain = _domain.strip().decode('utf-8').encode('idna')
            if domain not in domains:
                db_data[domain] = {"ip": {}, "ip6": {}, "last_update": 0, "ttl": 5}

    __save(db_data)

if __name__ == '__main__':
    main()
